#ifndef _FFT_HEADER
#define _FFT_HEADER

#define PI 3.1415926

typedef struct Complex {
	//a + bi
	double a;
	double b;
} Complex;

void print_Complex(Complex a);

Complex add_Complex_Complex(Complex a, Complex b);
Complex sub_Complex_Complex(Complex a, Complex b);
Complex mul_Complex_Complex(Complex a, Complex b);
Complex div_Complex_Complex(Complex a, Complex b);

void FFT_init(int lambda, long long root, long long inv_root, long long inv_n);
//void FFT_R(long long *z, Complex *c, int len, int opt);
void FFT_R(long long *input, long long *output, int len, int opt);
void FFT_K(double *z, Complex *c, int len, int opt);

#endif
