#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "BasicScheme.h"
#include "sig_api.h"

int main() {
	//clock_t start, step1, step2, step3;
	
	srand((unsigned)time(NULL));
	
	parameter_init(128);//Ϊ128256
	
	unsigned char *pk = (unsigned char*)malloc(sizeof(unsigned char) * SIG_SECRETKEYBYTES);
	unsigned char *sk = (unsigned char*)malloc(sizeof(unsigned char) * SIG_PUBLICKEYBYTES);
	
	unsigned char message[60 + 40];//40ֽΪ
	
	long long i;
	for(i = 0; i < sizeof(message); i++) {
		message[i] = rand() % 256;
	}
	
	unsigned char *sig = (unsigned char*)malloc(sizeof(unsigned char) * SIG_BYTES);
	unsigned long long sig_len;
	
	//start = clock();
	
	sig_keygen(pk, sk);
	
	//step1 = clock();
	
	sig_sign(sk, message, sizeof(message), sig, &sig_len);
	
	//step2 = clock();
	
	sig_verf(pk, sig, sig_len, message, sizeof(message));
	

	//step3 = clock();

	//printf("%d, %d, %d\n", step1 - start, step2 - step1, step3 - step2);
	
	//system("pause");
	
	return 0;
}
