#ifndef _RANDOM_GENERATOR_HEADER
#define _RANDOM_GENERATOR_HEADER

#include "util.h"

long long generate_randomBnd(long long q);

double generate_Gaussian(double mean, double standard_deviation);

poly_R generate_random_poly_R(long long n);

mat_poly_R generate_Gaussian_mat_poly_R(long long n, long long a, long long b, double sigma);

poly_K generate_Gaussian_poly_K(long long n, double sigma);

long long Oracle_1(double c, double standard_deviation);

long long Oracle_2(long long coset, double standard_deviation);

#endif
